//
// VNC Viewer for B-right/V
// (C)Copyright 2004, Yashiro Takeshi
//

#ifndef DEFINE_H_HOST_INPUT_PANEL
#define DEFINE_H_HOST_INPUT_PANEL

#include <basic.h>
#include <btron/hmi.h>
#include <btron/libapp.h>
#include <tstring.h>
#include <bstdio.h>
#include "databox.h"

class HostInputPanel {
  friend W impl_hostInputPanel(W pnid, W ino, W value);

public:
  const static int maxlength = 24;

private:
  W panel_id;
  static TC hostname[maxlength+1];
  static W dispnum;

public:
  HostInputPanel(){
    panel_id = opnstdpnl(PNL_HOSTINP, 0);
    setDispNumber(3);
    setHostname((TC[]){TNULL});
  }
  
  ~HostInputPanel(){
    if (panel_id >= 0){
      clsstdpnl();
    }
  }

  void setHostname(const TC* str){
    tc_strcpy(hostname, const_cast<TC*>(str));
    cset_val(pidstdpnl(3), tc_strlen(hostname)*2, (W*)hostname);
  }
  
  void setDispNumber(int num){
    dispnum = num;
    cset_val(pidstdpnl(4), 1, &dispnum);
  }
  
  int getDispNumber() const {
    return dispnum;
  }
  
  const TC* getHostname() const {
    return hostname;
  }
  
  int exec();
};

#endif // DEFINE_H_HOST_INPUT_PANEL
