//
// VNC Viewer for B-right/V
// (C)Copyright 2004, Yashiro Takeshi
//

#include <basic.h>
#include <btron/dp.h>
#include <keycode.h>
#include "VncApplication.h"
#include "ywindow.h"
#include "VncWindow.h"
#include <bstdio.h>
#include "databox.h"

extern MENUITEM mitem[];

W VncApplication::run()
{
  W evType;
  YWindow* win;
  WEVENT event;
  // if (event.s.wid != windowID) outside of window
  // if(event.s.cmd != W_WORK) outside of working area

  do {
    evType = wget_evt(&event, evmode);
    win = getWindow(event.g.wid);

    switch (evType){
      
    case EV_MSG:
      clr_msg(MM_ALL, MM_ALL);
      break; // usual events
      
    case EV_REQUEST:
      switch (event.r.cmd){
        
      case W_REDISP:
        if (win != NULL){
          win->onRepaint();
        }
        break;
        
      case W_PASTE:
        wrsp_evt(&event,YWindow::NACK);
        // closeWindow();
        break;
        
      case W_FINISH:
        wrsp_evt(&event,YWindow::ACK);
        if (win != NULL){
          win->closeWindow();
        }
        terminate(0);
        // return event.g.cmd
        break;
        
      case W_DELETE:
        wrsp_evt(&event,YWindow::ACK);
        // save Document here!
        //  ---
        if (win != NULL){
          win->closeWindow();
        }
        terminate(0);
        break;
        
      default:
        break; // ignore the rests
        
      }
      break;
      
    case EV_INACT:
      // ex: no-op
      break;
      
    case EV_RSWITCH:
      if (win != NULL){
        win->onRepaint();
      }
    case EV_SWITCH:
      if (event.s.cmd < W_WORK || event.s.cmd > W_LBAR){
        break;
      }
      break;
      
    case EV_MENU:
      if (win == NULL || event.s.wid != win->getWindowID()
          || event.s.cmd != W_WORK){
        // real menu
        YWindow *w = getWindow(wget_act(NULL));
        
        wget_dmn(&(mitem[3].ptr));
        mset_itm(((VncWindow*)w)->mid, 3, &mitem[3]);
        oget_men(0, NULL, &(mitem[4].ptr), NULL, NULL);
        mset_itm(((VncWindow*)w)->mid, 4, &mitem[4]);
        
        // set/unset indicator
        WDSTAT stat;
        wget_sts(w->getWindowID(), &stat, NULL);
        if ((stat.attr & WA_FULL) != 0){
          mitem[1].select |= 2;
        }
        else {
          mitem[1].select &= ~2;
        }
        mset_itm(((VncWindow*)w)->mid, 1, &mitem[1]);

        // enable/disable send
        if (tget_sts(NULL, NULL) == 0){
          mitem[2].inact |= 2;
        }
        else {
          mitem[2].inact &= ~2;
        }
        // enable/disable receive
        if (((VncWindow*)w)->trayString.isEmpty()){
          mitem[2].inact |= 4;
        }
        else {
          mitem[2].inact &= ~4;
        }
        mset_itm(((VncWindow*)w)->mid, 2, &mitem[2]);

        gset_ptr(PS_SELECT, NULL, (unsigned)-1, (unsigned)-1);
        int sel = msel_men(((VncWindow*)w)->mid, event.s.pos);
        if (sel > 0){
          ((VncWindow*)w)->onMenu(sel);
        }
        break;
      }
      gcnv_rel(wget_gid(win->getWindowID()), &event.s.pos);
    case EV_BUTDWN:
      if (win != NULL){
        win->onMouseButtonDown(&event);
      }
      break;
    case EV_BUTUP:
      if (win != NULL){
        win->onMouseButtonUp(&event);
      }
      break;

    case EV_KEYDWN:
      win = getWindow(wget_act(NULL));
      if (win != 0){
        win->onKeyDown(&event);
        win->onKeyTyped(&event);
      }
      break;
    case EV_AUTKEY:
      // key inputs
      win = getWindow(wget_act(NULL));
      if (win != 0){
        if (((EVENT*)&event)->data.key.code == KC_SS_D || ((EVENT*)&event)->data.key.code == KC_SS_U){
          win->onMouseWheel(&event);
        }
        else {
          win->onKeyTyped(&event);
        }
      }
      break;
    case EV_KEYUP:
      win = getWindow(wget_act(NULL));
      if (win != 0){
        win->onKeyUp(&event);
      }
      break;

    case EV_NOMSG:
      //break; // happens only if NOWAIT
    case EV_NULL:
      //if (event.s.cmd == W_WORK){
        //gset_ptr(PS_SELECT,NULL,-1,-1);
        //setpointer(PS_SELECT,NULL);
      //}
      /*if (win != NULL){
        win->onIdle(&event);
      }*/
      for (std::map<W,YWindow*>::iterator i = hashWnd.begin(); i != hashWnd.end(); i++){
        i->second->onIdle(&event);
      }
      break;
      //if (event.s.stat & ES_CMD){
      // command key pressed
      //break;
      //}
      //setpointer(PS_SELECT,NULL);

    case EV_DEVICE:
      // FD inserted
      oprc_dev(&event.e,NULL,0);
      break;
      
    default:
      // others
      break;
    }
  } while (!toBeKilled);
  
  return ret_code;
}
