//
// VNC Viewer for B-right/V
// (C)Copyright 2004, Yashiro Takeshi
//

#include <basic.h>
#include <bstdio.h>
#include <bassert.h>
#include <btron/libapp.h>

#include "databox.h"
#include "ytcpsocket.h"
#include "yglobaldefs.h"
#include "VncApplication.h"
#include "ywindow.h"
#include "ygraphic.h"
#include "yrect.h"
#include "ystring.h"
#include "ysemaphore.h"
#include "rfbTransactions.h"
#include "rfbproto.h"
#include "VncWindow.h"
#include "HostInputPanel.h"
#include "PasswordInputPanel.h"
#include "errorpanel.h"

static W vid = -1, wid = -1, mid = -1;

static TC mlist0[] = {
  MC_STR|MC_KEY1, L"Žλ"
};
static TC mlist1[] = {
  MC_STR, L"ɽ" |
  MC_IND, L"ɽ" |
  MC_STR, L"ɽ"
};
static TC mlist2[] = {
  MC_STR, L"ȥ졼" |
  MC_STR, L"ƥ" |
  MC_STR, L"ƥȼ"
};

MENUITEM mitem[5] = {
  0L, 0L, 0, 0, mlist0,
  0L, 0L, 0, 0, mlist1,
  0L, 0L, 0, 0, mlist2,
  0L, 0L, 0, 0, NULL,
  0L, 0L, 0, 0, NULL,
};

struct VncFusen {
  H dlen;
  H mode;
  YRect rect;
  H full;
};

static VncFusen fusen = {
  sizeof(VncFusen) - sizeof(H),
  0,
  YRect(20, 20, 620, 470),
  0
};

// ---------------------

void killme()
{
  gset_ptr(PS_BUSY, NULL, (unsigned int)-1, (unsigned int)-1);

  if (mid >= 0){
    mdel_men(mid);
    mid = -1;
  }
  closedbox();
  if (vid >= 0){
    oend_prc(vid, NULL, 1);
    vid = wid = -1;
  }
  ext_prc(0);
}

// ----------------------------------------------------
//  ᥤ
// ----------------------------------------------------
extern "C" W MAIN(MESSAGE *msg)
{
  char hostname[256];
  int disp_num;
  char password[256];
  TC buf[256];
  
  switch (msg->msg_type) {
  case DISPREQ:
    oend_req(((M_DISPREQ*)msg)->vid, -1);
    exit(1); // exit
  case PASTEREQ:
    oend_req(((M_PASTEREQ*)msg)->vid, -1);
    exit(1); // exit
  case EXECREQ:
    // ȵưξ
    if ((((M_EXECREQ*)msg)->mode & 2) == 0) {
      VncFusen fusenbuf;
      W fd;
      if ((fd = opn_fil(&(((M_EXECREQ*)msg)->lnk), F_READ, NULL)) < 0){
        break;
      }
      if (see_rec(fd, ((M_EXECREQ*)msg)->info, 1, NULL) < 0) {
	cls_fil(fd);
	break;
      }
      if (rea_rec(fd, 94, (B*)&fusenbuf, sizeof(VncFusen), NULL, NULL) < 0){
        cls_fil(fd);
        break;
      }
      cls_fil(fd);
      if (fusen.dlen == fusenbuf.dlen){
        fusen = fusenbuf;
      }
      break;
    }
  default:
    // ¾ξ
    pdsp_msg((TC[]){L"Ȥ餷¹ԤǤޤ"});
    sig_buz(0);
    exit(1);
  };

  LINK lnk;

  prc_inf(0, PI_LINK, &lnk, sizeof(LINK));
  if (opendbox(&lnk, USER_DATA, 0x2000) < 0){
    printf("%d\n", USER_DATA);
    exit(0);
  }
  getscreen();
  initstdpnl();
  W mid = mcre_men(5, mitem, NULL); //openmenu(MENU);

  HostInputPanel h_panel;
  // ۥȾɤ߹
  W fd0 = oopn_obj(((M_EXECREQ*)msg)->vid, &(((M_EXECREQ*)msg)->lnk),
                   F_READ, NULL);
  if (fd0 < 0){
    killme();
  }
  if (fnd_rec(fd0, F_TOPEND, 1 << 31, 0, NULL) >= 0){
    see_rec(fd0, 0, 0, NULL);
    rea_rec(fd0, 0, (B*)buf, sizeof(buf), NULL, NULL);
    rea_rec(fd0, sizeof(buf), (B*)&disp_num, sizeof(int), NULL, NULL);
  }
  else {
    disp_num = 0;
    buf[0] = TNULL;
  }
  cls_fil(fd0);
  // ۥȾ(ѥͥ)
  h_panel.setDispNumber(disp_num);
  h_panel.setHostname(buf);
  if (h_panel.exec() == 0){
    killme();
  }
  disp_num = h_panel.getDispNumber();
  tc_strcpy(buf, const_cast<TC*>(h_panel.getHostname()));
  // ۥȾ¸
  fd0 = oopn_obj(((M_EXECREQ*)msg)->vid, &(((M_EXECREQ*)msg)->lnk),
                 F_WRITE, NULL);
  if (fd0 < 0){
    killme();
  }
  if (fnd_rec(fd0, F_TOPEND, 1 << 31, 0, NULL) >= 0){
    see_rec(fd0, 0, 0, NULL);
  }
  else {
    apd_rec(fd0, (B*)buf, sizeof(buf) + sizeof(int), 31, 0, 0);
    see_rec(fd0, -1, -1, NULL);
  }
  wri_rec(fd0, 0, (B*)buf, sizeof(buf), NULL, NULL, 0);
  wri_rec(fd0, sizeof(buf), (B*)&disp_num, sizeof(int), NULL, NULL, 0);
  cls_fil(fd0);
  sprintf(hostname, "%S", buf); 

  try {
    app = new VncApplication;
    //app->setEventMode(NOWAIT);

    YLibDraft::YTCPSocket sock(SOCK_STREAM);
    sock.connect(hostname, 5900 + disp_num);
    
    // Protocol Version
    int ver, subver;
    if (!execVNCProtocolVersion(&sock, &ver, &subver)){
      YString str((TC[]){L"ץȥ뤬ңƣ¤ǤϤޤ"});
      throw new YException(str);
    }
    //printf("RFB Protocol version %d.%d\n", ver, subver);
    
    // Authentication
    unsigned long auth_method;
    sock.read((B*)&auth_method, 4);
    auth_method = htonl(auth_method);
    switch (auth_method) {
    case 0:
      // connection failed
      {
        YString str((TC[]){L"Ф³ݤޤ"});
        throw new YException(str);
      }
      break;
    case 1:
      // no authentication
      break;
    case 2:
      // VNC authentication
      {
        PasswordInputPanel p_panel;
        if (p_panel.exec() == 0){
          //sock.close();
          killme();
        }
        sprintf(password, "%S", p_panel.getPassword());
        if (execVNCAuthentication(&sock, password) != 0){
          YString str((TC[]){L"ѥɤְäƤޤ"});
          throw new YException(str);
        }
      }
      break;
    default:
      // unknown authentication
      {
        YString str((TC[]){L"եȤǧˡбƤޤ"});
        throw new YException(str);
      }
      break;
    };
    
    // Client Initialization
    char shared_flag = 0;
    sock.write(&shared_flag, 1);

    // Server Initialization
    rfbServerInitMsg server_init;
    TC *servname = execVNCServerInitalization(&sock, &server_init);
    YString title;
    title = concat((TC[]){L"̣֣Σá"}, servname);
    delete servname;

    // SetPixelFormat
    execVNCSetPixelFormat(&sock, &server_init);

    // SetEncoding
    execVNCSetEncoding(&sock);

    // initial framebuffer request
    YRect rect(0, 0, server_init.framebufferWidth, server_init.framebufferHeight);
    requestVNCFramebufferUpdate(&sock, 0, rect, true);

    // Window Open
    VncWindow wnd;
    wnd.setTitle(title);
    wnd.setPosition(fusen.rect);
    wnd.setAttributes(WA_NORMAL | WA_FRAME);
    wnd.sock = &sock;
    wnd.server = &server_init;
    wnd.mid = mid;
    wnd.openWindow();
    if (fusen.full){
      wchg_wnd(wnd.getWindowID(), NULL, W_MOVE);
      wreq_dsp(wnd.getWindowID());
    }
    
    vid = ((M_EXECREQ*)msg)->vid;
    wid = wnd.getWindowID();
    osta_prc(wid, vid);

    app->registerWindow(&wnd);

    app->run();
    
    wnd.closeWindow();
    
    // write fusen
    wnd.getPosition(&(fusen.rect), &(fusen.full));
    W fd = opn_fil(&(((M_EXECREQ*)msg)->lnk), F_UPDATE, NULL);
    if (fd >= 0){
      oput_fsn(((M_EXECREQ*)msg)->vid, fd, &fusen);
      cls_fil(fd);
    }
  }
  catch (YException *e) {
    errorpanel((const TC*)e->getMessage());
  }
  catch (...) {
    const TC p[] = {L"곰Υ顼ȯޤ"};
    errorpanel(p);
  }
  killme();
}
