//  Test Program for YLib
//  (C)Copyright 2003, Yashiro Takeshi

#include "yglobaldefs.h"
#include "yapplication.h"
#include "ywindow.h"
#include "yrect.h"
#include "ypoint.h"
//#include <bstdio.h>
#include "ystring.h"

class YMainWindow : public YWindow {
public:
  void onDraw(YGraphic *gr);
};

void YMainWindow::onDraw(YGraphic *gr)
{
  YPen pen;
  gr->setPen(&pen);
  
  gr->line(YPoint(0,0),YPoint(100,100));
  
  pen.setLineWidth(3);
  pen.setFgColor(YColor(0,128,0));
  gr->setPixel(YPoint(70,80));
  
  pen.setLinePattern(LN_DASH);
  gr->frameRect(YRect(30,20,140,130),20);
  
  pen.setFgColor(YColor(20,120,230));
  pen.setLinePattern(LN_SOLID);
  gr->frameRoundRect(YRect(40,10,150,180),30,40,30);
  
  pen.setDrawingMode(G_XOR);
  gr->frameOval(YRect(20,40,120,90),50);
  
  // brushes
  YBrush brush;
  gr->setBrush(&brush);

  gr->fillRect(YRect(150,150,180,170),0);

  brush.setFgColor(YColor(0,128,64));
  brush.setMask(FILL50);
  gr->fillRect(YRect(160,190,250,240),35);
  
  return;
}

extern "C" W MAIN(M_EXECREQ *msg)
{
  int ret_code=0;

  app = new YApplication;

  YMainWindow wnd,wnd2;
  try {
    /*switch (msg->type){
    case EXECREQ:
      if ((msg->mode & 2) == 0){
	break;
      }
      throw;
    case DISPREQ:
      throw;
    case PASTEREQ:
      throw;
    default:
      throw ((TC[]){L"Ȥ餷¹ԤǤޤ"});
    }*/
    
    wnd.setTitle((TC[]){L"ɥ"});
    wnd.setPosition(YRect(20,20,420,320));
    wnd.setAttributes(WA_NORMAL);
    wnd.openWindow();
    
    wnd2.setTitle((TC[]){L"⤦Ĥɤ"});
    wnd2.setPosition(YRect(520,80,940,380));
    wnd2.setAttributes(WA_STD);
    wnd2.openWindow();
    
    app->registerWindow(&wnd);
    app->registerWindow(&wnd2);
    
    ret_code = app->run();
  }
  catch (YException *e){
    const TC* str = e->getMessage();
    pdsp_msg(const_cast<TC*>(str));
  }
  catch (...){
    pdsp_msg((TC[]){L"̤Τ㳰ȯޤ"});
  }
  wnd.closeWindow();
  wnd2.closeWindow();
  
  delete app;

  return ret_code;
}

