/**
 * @file ygraphic.cc
 * @brief եå ()
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-28
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#include "ygraphic.h"
#include "ypen.h"
#include "ybrush.h"

YPen* YGraphic::stdPen = 0;

YBrush* YGraphic::stdBrush = 0;

/// ǥեȥ󥹥ȥ饯
YGraphic::YGraphic()
{
  graphID = -1;
  setPen(getStdPen());
  setBrush(getStdBrush());
}

/** 󥹥ȥ饯
 *
 * 󥹥ȥ饯ǤIDȤδϢŤƱ˹Ԥޤ
 * @param gid ID
 */
YGraphic::YGraphic(W gid)
{
  setGraphID(gid);
  setPen(getStdPen());
  setBrush(getStdBrush());
}

/** ڥڤؤ
 *
 * Ѥ°(ڥ)ڤؤΥڥؤΥݥ󥿤֤ޤ
 * @param pen ڥ
 * @return ѹΥڥ
 */
YPen* YGraphic::setPen(YPen *pen)
{
  YPen* oldpen = currentPen;
  currentPen = pen;
  return oldpen;
}

/** ֥饷ڤؤ
 *
 * ѤɤĤ֤°(֥饷)ڤؤΥ֥饷ؤΥݥ󥿤֤ޤ
 * @param brush ֥饷
 * @return ѹΥ֥饷
 */
YBrush* YGraphic::setBrush(YBrush *brush)
{
  YBrush* oldbrush = currentBrush;
  currentBrush = brush;
  return oldbrush;
}

/** ɸڥγ
 *
 * ɸڥؤΥݥ󥿤ޤ
 * @return ɸڥؤΥݥ
 */
YPen* YGraphic::getStdPen()
{
  if (stdPen == 0){
    stdPen = new YPen();
  }
  return stdPen;
}

/** ɸ֥饷γ
 *
 * ɸ֥饷ؤΥݥ󥿤ޤ
 * @return ɸ֥饷ؤΥݥ
 */
YBrush* YGraphic::getStdBrush()
{
  if (stdBrush == 0){
    stdBrush = new YBrush();
  }
  return stdBrush;
}

/** ľ
 *
 * ľ褷ޤ
 * @param p1 üκɸ(start)
 * @param p2 üκɸ(end)
 */
void YGraphic::line(const YPoint& p1, const YPoint& p2)
{
  gdra_lin(graphID, (PNT)p1, (PNT)p2, currentPen->getAttr(),
           &(currentPen->pat), currentPen->getDrawingMode());
  return;
}

/** 
 *
 * (ԥ륵)褷ޤ
 * @param p1 κɸ
 */
void YGraphic::setPixel(const YPoint& p1)
{
  gdra_pnt(graphID, (PNT)p1, currentPen->getFgColor().getColorValue(),
           currentPen->getDrawingMode());
  return;
}

/** Υѥ
 *
 * (ԥ륵)ѥ褷ޤ
 * @param p1 κɸ
 */
void YGraphic::fillPixel(const YPoint& p1)
{
  gfil_pnt(graphID, (PNT)p1, &(currentBrush->pat), currentBrush->getDrawingMode());
  return;
}

/** ĹȤ
 *
 * ĹȤ褷ޤ
 * @param rect ͳѷΰ
 * @param deg ž
 */
void YGraphic::frameRect(const YRect& rect, W deg = 0)
{
  gfra_rec(graphID, (RECT)rect, currentPen->getAttr(), &(currentPen->pat),
           adjustDeg(deg), currentPen->getDrawingMode());
  return;
}

/* ĹΰɤĤ֤
 *
 * ĹΰȤɤĤ֤ޤ
 * @param rect ͳѷΰ
 * @deg ž
 */
void YGraphic::fillRect(const YRect& rect, W deg = 0)
{
  gfil_rec(graphID, (RECT)rect, &(currentBrush->pat),
           adjustDeg(deg), currentBrush->getDrawingMode());
  return;
}

/** ѴĹȤ
 *
 * ѴĹȤ褷ޤ
 * @param rect ͳѷΰ
 * @param rx xδݤľ
 * @param ry yδݤľ
 * @param deg ž
 */
void YGraphic::frameRoundRect(const YRect& rect, W rx, W ry, W deg = 0)
{
  gfra_rrc(graphID, (RECT)rect, (rx >= 0 ? rx : 0), (ry >= 0 ? ry : 0),
           currentPen->getAttr(), &(currentPen->pat), adjustDeg(deg),
           currentPen->getDrawingMode());
  return;
}

/** ѴĹΰɤĤ֤
 *
 * ѴĹΰȤɤĤ֤ޤ
 * @param rect ͳѷΰ
 * @param rx xδݤľ
 * @param ry yδݤľ
 * @param deg ž
 */
void YGraphic::fillRoundRect(const YRect& rect, W rx, W ry, W deg = 0)
{
  gfil_rrc(graphID, (RECT)rect, (rx >= 0 ? rx : 0), (ry >= 0 ? ry : 0),
           &(currentBrush->pat), adjustDeg(deg), currentBrush->getDrawingMode());
  return;
}

/** ʱȤ
 *
 * ʱ߷Ȥ褷ޤ
 * @param rect ͳѷΰ
 * @param deg ž
 */
void YGraphic::frameOval(const YRect& rect, W deg = 0)
{
  gfra_ovl(graphID, (RECT)rect, currentPen->getAttr(), &(currentPen->pat),
           adjustDeg(deg), currentPen->getDrawingMode());
  return;
}

/** ʱΰɤĤ֤
 *
 * ʱ߷ȤɤĤ֤ޤ
 * @param rect ͳѷΰ
 * @param deg ž
 */
void YGraphic::fillOval(const YRect& rect, W deg = 0)
{
  gfil_ovl(graphID, (RECT)rect, &(currentBrush->pat),
           adjustDeg(deg), currentBrush->getDrawingMode());
  return;
}

/** ̤
 *
 * ʱߤθ̤褷ޤ
 * @param rect ͳѷΰ
 * @param sp 
 * @param ep λ
 * @param deg ޷ž
 */
void YGraphic::arc(const YRect& rect, const YPoint& sp,
                   const YPoint& ep, W deg = 0)
{
  gdra_arc(graphID, (RECT)rect, (PNT)sp, (PNT)ep, currentPen->getAttr(),
           &(currentPen->pat), adjustDeg(deg), currentPen->getDrawingMode());
  return;
}

/** Ȥ
 *
 * Ȥ褹
 * @param rect ͳѷΰ
 * @param sp 
 * @param ep λ
 * @param deg ž
 */
void YGraphic::frameSector(const YRect& rect, const YPoint& sp,
                           const YPoint& ep, W deg = 0)
{
  gfra_sec(graphID, (RECT)rect, (PNT)sp, (PNT)ep, currentPen->getAttr(),
           &(currentPen->pat), adjustDeg(deg), currentPen->getDrawingMode());
  return;
}

/** ΰɤĤ֤
 *
 * ȤɤĤ֤ޤ
 * @param rect ͳѷΰ
 * @param sp 
 * @param ep λ
 * @param deg ž
 */
void YGraphic::fillSector(const YRect& rect, const YPoint& sp,
                          const YPoint& ep, W deg = 0)
{
  gfil_sec(graphID, (RECT)rect, (PNT)sp, (PNT)ep, &(currentBrush->pat),
           adjustDeg(deg), currentBrush->getDrawingMode());
  return;
}

/** ݷȤ
 *
 * ݷȤ褷ޤ
 * @param rect ͳѷΰ
 * @param sp 
 * @param ep λ
 * @param deg ž
 */
void YGraphic::frameChord(const YRect& rect, const YPoint& sp,
                          const YPoint& ep, W deg = 0)
{
  gfra_cho(graphID, (RECT)rect, (PNT)sp, (PNT)ep, currentPen->getAttr(),
           &(currentPen->pat), adjustDeg(deg), currentPen->getDrawingMode());
  return;
}

/** ݷΰɤĤ֤
 *
 * ݷȤɤĤ֤ޤ
 * @param rect ͳѷΰ
 * @param sp 
 * @param ep λ
 * @param deg ž
 */
void YGraphic::fillChord(const YRect& rect, const YPoint& sp,
                         const YPoint& ep, W deg = 0)
{
  gfil_cho(graphID, (RECT)rect, (PNT)sp, (PNT)ep, &(currentBrush->pat),
           adjustDeg(deg), currentBrush->getDrawingMode());
  return;
}

/** ǤΰɤĤ֤
 *
 * ǤդΰɤĤ֤ޤϻꤵ줿ɸˤԥ
 * ʳ()ƤȤʤޤ
 * @param pt Ȥʤɸ
 */
void YGraphic::floodFill(const YPoint& pt)
{
  gfil_rgn(graphID, -1, (PNT)pt, &(currentBrush->pat),
           currentBrush->getDrawingMode());
  return;
}

/** ǤΰɤĤ֤
 *
 * ǤդΰɤĤ֤ޤͿ줿Ȥʤޤ
 * @param pt ɸ
 * @param bound 
 */
void YGraphic::floodFill(const YPoint& pt, const YColor& bound)
{
  gfil_rgn(graphID, currentBrush->getFgColor().getColorValue(), (PNT)pt,
           &(currentBrush->pat), currentBrush->getDrawingMode());
  return;
}

