/**
 * @file ymenu.h
 * @brief ˥塼
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-31
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YMENU
#define DEFINE_H_YMENU

#include <vector>
#include <map>
#include <basic.h>
#include <btron/hmi.h>
#include "yaction.h"
#include "ystring.h"

class YMenuSeparator;
class YMenuLabel;
class YMenuParentLabel;

/** ˥塼
 *
 * ˥塼Ǥδ쥯饹Ƽ˥塼ƥΥեȥ꡼ˤ
 * ʤäƤޤ
 */
class YMenuItem {

protected:
  enum YMenuItemType { LABEL, SEPARATOR, SWITCH, PARENT } type;
  
public:
  /// ѥ졼
  YMenuSeparator* createSeparator();

  /// ٥
  YMenuLabel* createLabel(const YString& label, YAction* act, bool inactive = false);

  /// 󥸥
  YMenuLabel* createSwitch(const YString& label, YAction* act, bool indicator = false, bool inact = false);

  /// ˥塼οƹܤ
  YMenuParentLabel* createParentLabel(const YString& label, bool inactive = false);

};

/** ˥塼Υѥ졼
 *
 * ˥塼ǤΥѥ졼ɽޤ<br>
 * YMenuItem::createSeparator();<br>
 * Τ褦˹ԤäƤ
 */
class YMenuSeparator : public YMenuItem {
  friend class YMenuItem;
};

/** ˥塼ʸĤ
 *
 * ˥塼ǤʸǤɽޤ<br>
 * YMenuItem::createSwitch();<br>
 * YMenuItem::createLabel();<br>
 * Τ褦˹ԤäƤ
 */
class YMenuLabel : public YMenuItem {
  friend class YMenuItem;

protected:
  YAction *act;
  YString label;
  bool inact;
  bool indicator;
};

/** ˥塼ο
 *
 * ˥塼Ǥο(쥯)ѥ졼ɽޤ<br>
 * YMenuItem::createParentLabel();<br>
 * Τ褦˹ԤäƤ
 */
class YMenuParentLabel : public YMenuItem {
  friend class YMenuItem;
  
protected:
  YString label;
  std::vector<YMenuItem*> mitem;
  bool inact;

public:
  void add(YMenuItem *item);

};

/** ˥塼
 *
 * ˥塼̤ʤΤǡޤѤǤޤ
 */
class YMenu {
private:
  bool dirty;
  std::vector<YString*> menuitem;
  std::vector<YMenuItem*> menu;
  std::map<int, YAction*> actionMap;
  int currentChildNumber;
  
public:
  /// ǥեȥ󥹥ȥ饯
  YMenu() {
    currentChildNumber = 0;
    dirty = false;
  }
  
  /** ˥塼ܤɲ
   *
   * ˥塼ܤɲäޤYMenuItemΰϡɬnew黻Ҥ
   * ϤƤ
   */
  void addItem(YMenuItem* item);

  /// ǥȥ饯
  virtual ~YMenu() {
    // ǡʤ餺ƤΥ delete 뤳ȡ
    ;
  }
  
};
#endif // DEFINE_H_YMENU

